﻿--[[****************************************************************************
  * WoWHead Linker by Fredro                                                   *
  * wowheadlinker.lua - Converts wowhead.com item urls to in-game links        *
  
  Copyright (C) 2012 Fredrik Lundberg (Fredro)

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ****************************************************************************]]

SLASH_WOWHEADLINKER1 = "/whlink";
local function handler(msg, editbox)
	local command, url = msg:match("^(%S*)%s*(.-)$");
	
	if command == "" or url == "" then
		print("Syntax: /whlink ( self | say | player name | general | trade | party | raid | guild ) http://www.wowhead.com/item=XXX");
		return;
	end
	local itemNr = string.match(url,"%d+");
	local itemInfo = select(2,GetItemInfo(itemNr));

	if itemInfo == nil then
		print("Item is not in your cache, just re-run the command again");
		return;
	end
	if command == "self" and rest ~= "" then
		DEFAULT_CHAT_FRAME:AddMessage(itemInfo .." - Item parsed for your eyes only");
	elseif command == "say" and rest ~= "" then
		SendChatMessage(itemInfo,"SAY");
	elseif command == "trade" and rest ~= "" then
		local trID1 = select(1,GetChannelList());
		local trID2 = select(3,GetChannelList());
		if trID1 == 2 or trID2 == 2 then
			SendChatMessage(itemInfo,"CHANNEL",nil,2);
		else
			print("Error: Not in a Trade channel at the moment");
		end
	elseif command == "general" and rest ~= "" then
		local genID = select(1,GetChannelList());
		if genID == 1 then
			SendChatMessage(itemInfo,"CHANNEL",nil,1);
		else
			print("Error: Not in a General channel at the moment");
		end

	elseif command ~= "" and rest ~= "" and command ~="self" and command ~="say" and command ~="party" and command ~="raid" and command ~="guild" then
		SendChatMessage(itemInfo,"WHISPER", nil, command);
	elseif command == "party" and rest ~= "" then
		SendChatMessage(itemInfo,"PARTY");
	elseif command == "raid" and rest ~= "" then
		SendChatMessage(itemInfo,"RAID");
	elseif command == "guild" and rest ~= "" then
		SendChatMessage(itemInfo,"GUILD");
	else
		print("Syntax: /whlink ( self | say | player name | general | trade | party | raid | guild ) http://www.wowhead.com/item=XXX");
	end
end
SlashCmdList["WOWHEADLINKER"] = handler;